           (*-------------------------------------------*
            |               November 2007               |
            |                                           |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory CSP_F_law_aux_v4_1
imports CSP_F_law_aux CSP_syntax_v4_1 CSP_F_law_decompo_v4_1
begin

(*****************************************************************

         1. 

 *****************************************************************)

(*===============================================================*
 |  decompostion of Sequential composition with a flag           |
 |  It is often useful that the second process is not rewritten. |
 *===============================================================*)

lemma cspF_Seq_compo_mono_flag_v4_1:
  "[| P1 <=F[M1,M2] Q1 ; 
      Not_Rewrite_Flag & P2 <=F[M1,M2] Q2 |]
           ==> P1 ;; P2 <=F[M1,M2] Q1 ;; Q2"
by (simp add: cspF_Seq_compo_mono)

lemma cspF_Seq_compo_cong_flag_v4_1:
  "[| P1 =F[M1,M2] Q1 ; 
      Not_Rewrite_Flag & P2 =F[M1,M2] Q2 |]
           ==> P1 ;; P2 =F[M1,M2] Q1 ;; Q2"
by (simp add: cspF_Seq_compo_cong)

lemmas cspF_free_mono_flag_v4_1 =
       cspF_Ext_choice_mono cspF_Int_choice_mono cspF_Parallel_mono
       cspF_Hiding_mono cspF_Renaming_mono cspF_Seq_compo_mono_flag_v4_1
       cspF_Depth_rest_mono
       cspF_Rep_int_choice_mono_UNIV

       cspF_Alpha_parallel_mono


lemmas cspF_free_cong_flag_v4_1 =
       cspF_Ext_choice_cong cspF_Int_choice_cong cspF_Parallel_cong
       cspF_Hiding_cong cspF_Renaming_cong cspF_Seq_compo_cong_flag_v4_1
       cspF_Depth_rest_cong
       cspF_Rep_int_choice_cong_UNIV

       cspF_Alpha_parallel_cong

lemmas cspF_free_decompo_flag_v4_1 = cspF_free_mono_flag_v4_1 cspF_free_cong_flag_v4_1

lemmas cspF_mono_v4_1 = cspF_mono  cspF_prefix_ss_mono
lemmas cspF_cong_v4_1 = cspF_cong  cspF_prefx_ss_cong
lemmas cspF_decompo_v4_1 = cspF_mono_v4_1 cspF_cong_v4_1

end
